#include "Node.h"
Node::Node(void):
    _next(this),_prev(this)
    {
    }

Node *Node::next(void)
    {
        return _next;
    }

Node::~Node(void)
    {

    }

Node *Node::insert(Node* b)
    {
        Node *c = _next;
        b->_next = c;
        _next = b;
        c->_prev = b;
        return b;
    }

Node *Node::prev(void)
    {
        return _prev;
    }

void Node::splice(Node* b)
    {
        Node *a = this;
        Node *an = a->_next;
        Node *bn = b->_next;
        a->_next = bn;
        b->_next = an;
        an->_next = b;
        bn->_next = a;
    }

Node *Node::remove(void)
    {
        _prev->_next = _next;
        _next->_prev = _prev;
        _next = _prev = this;
        return this;
    }
